Code

Merge branch 'maint'
[git.git] / git-sh-setup.sh
index 4ed07e9ddca885e8a4f184a68bb6363fdc7c56e9..5aa62dda15d1c24d0b01845ded4c8bc15e98bf8a 100755 (executable)
@@ -6,7 +6,7 @@
 # it dies.
 
 # Having this variable in your environment would break scripts because
-# you would cause "cd" to be be taken to unexpected places.  If you
+# you would cause "cd" to be taken to unexpected places.  If you
 # like CDPATH, define it for your interactive shell sessions without
 # exporting it.
 unset CDPATH
@@ -16,9 +16,40 @@ die() {
        exit 1
 }
 
-usage() {
-       die "Usage: $0 $USAGE"
-}
+if test -n "$OPTIONS_SPEC"; then
+       usage() {
+               exec "$0" -h
+       }
+
+       parseopt_extra=
+       [ -n "$OPTIONS_KEEPDASHDASH" ] &&
+               parseopt_extra="--keep-dashdash"
+
+       eval "$(
+               echo "$OPTIONS_SPEC" |
+                       git rev-parse --parseopt $parseopt_extra -- "$@" ||
+               echo exit $?
+       )"
+else
+       usage() {
+               die "Usage: $0 $USAGE"
+       }
+
+       if [ -z "$LONG_USAGE" ]
+       then
+               LONG_USAGE="Usage: $0 $USAGE"
+       else
+               LONG_USAGE="Usage: $0 $USAGE
+
+$LONG_USAGE"
+       fi
+
+       case "$1" in
+               -h|--h|--he|--hel|--help)
+               echo "$LONG_USAGE"
+               exit
+       esac
+fi
 
 set_reflog_action() {
        if [ -z "${GIT_REFLOG_ACTION:+set}" ]
@@ -28,6 +59,22 @@ set_reflog_action() {
        fi
 }
 
+git_editor() {
+       : "${GIT_EDITOR:=$(git config core.editor)}"
+       : "${GIT_EDITOR:=${VISUAL:-${EDITOR}}}"
+       case "$GIT_EDITOR,$TERM" in
+       ,dumb)
+               echo >&2 "No editor specified in GIT_EDITOR, core.editor, VISUAL,"
+               echo >&2 "or EDITOR. Tried to fall back to vi but terminal is dumb."
+               echo >&2 "Please set one of these variables to an appropriate"
+               echo >&2 "editor or run $0 with options that will not cause an"
+               echo >&2 "editor to be invoked (e.g., -m or -F for git-commit)."
+               exit 1
+               ;;
+       esac
+       eval "${GIT_EDITOR:=vi}" '"$@"'
+}
+
 is_bare_repository () {
        git rev-parse --is-bare-repository
 }
@@ -44,8 +91,7 @@ cd_to_toplevel () {
 }
 
 require_work_tree () {
-       test $(git rev-parse --is-inside-work-tree) = true &&
-       test $(git rev-parse --is-inside-git-dir) = false ||
+       test $(git rev-parse --is-inside-work-tree) = true ||
        die "fatal: $0 cannot be used without a working tree."
 }
 
@@ -76,31 +122,26 @@ get_author_ident_from_commit () {
        LANG=C LC_ALL=C sed -ne "$pick_author_script"
 }
 
-if [ -z "$LONG_USAGE" ]
-then
-       LONG_USAGE="Usage: $0 $USAGE"
-else
-       LONG_USAGE="Usage: $0 $USAGE
-
-$LONG_USAGE"
-fi
-
-case "$1" in
-       -h|--h|--he|--hel|--help)
-       echo "$LONG_USAGE"
-       exit
-esac
-
 # Make sure we are in a valid repository of a vintage we understand.
 if [ -z "$SUBDIRECTORY_OK" ]
 then
        : ${GIT_DIR=.git}
-       GIT_DIR=$(GIT_DIR="$GIT_DIR" git rev-parse --git-dir) || {
+       test -z "$(git rev-parse --show-cdup)" || {
                exit=$?
                echo >&2 "You need to run this command from the toplevel of the working tree."
                exit $exit
        }
 else
-       GIT_DIR=$(git rev-parse --git-dir) || exit
+       GIT_DIR=$(git rev-parse --git-dir) || {
+           exit=$?
+           echo >&2 "Failed to find a valid git directory."
+           exit $exit
+       }
 fi
+
+test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
+    echo >&2 "Unable to determine absolute path of git directory"
+    exit 1
+}
+
 : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}